// jshint esnext: true

var B = require('bluebird'),
    request = require('request'),
    path = require('path'),
    fs = require('fs'),
    ps = require('promise-streams'),
    select = require('select-elements');

B.promisifyAll(request);

var download = url =>
  request('http:' + url).pipe(
    fs.createWriteStream(
        'images/' + path.basename(url)));

var imageStreams = urls =>
  B.all(urls.map(url =>
    request(url)
    .pipe(select('.post a img', el => el.attributes.SRC))
    .pipe(ps.map(imgurl => ps.wait(download(imgurl))))
    .wait()));

imageStreams(['http://imgur.com/']).done(
    urls => console.log(urls.length, "urls downloaded"),
    err     => console.error(err.stack))

